typedef struct Screen TScreen;

typedef struct  Image {
  TScreen       *OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  unsigned int  PictureWidth;
  unsigned int  PictureHeight;
  const far char    *Picture_Name;
  char          Visible;
  char          Active;
  char          AutoSize;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TImage;

typedef struct  Box {
  TScreen       *OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Line {
  TScreen       *OwnerScreen;
  char          Order;
  unsigned int  First_Point_X;
  unsigned int  First_Point_Y;
  unsigned int  Second_Point_X;
  unsigned int  Second_Point_Y;
  char          Pen_Width;
  char          Visible;
  char          Active;
  unsigned int  Color;
} TLine;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           ImagesCount;
  TImage                 **Images;
  unsigned int           BoxesCount;
  TBox                   **Boxes;
  unsigned int           LinesCount;
  TLine                 **Lines;
};

extern   TScreen                Screen1;
extern   TBox                   Box1;
extern   TImage                 Image1;
extern   TImage                 SelectPen;
extern   TImage                 SelectEraser;
extern   TImage                 BackgroundColor;
extern   TLine                  Line1;
extern   TLine                  Line2;
extern   TBox                   Box2;
extern   TBox                   Box3;
extern   TBox                   Box4;
extern   TBox                   Box5;
extern   TBox                   Box6;
extern   TBox                   Box7;
extern   TBox                   Box8;
extern   TBox                   Box9;
extern   TBox                   Box10;
extern   TBox                   Box11;
extern   TBox                   Box12;
extern   TBox                   Pen1;
extern   TBox                   Pen2;
extern   TBox                   Pen3;
extern   TBox                   Pen4;



/////////////////////////
// Events Code Declarations
void Box1Press();
void Image1Click();
void SelectPenPress();
void SelectEraserPress();
void BackgroundColorPress();
void Box2Press();
void Box3Press();
void Box4Press();
void Box5Press();
void Box6Press();
void Box7Press();
void Box8Press();
void Box9Press();
void Box10Press();
void Box11Press();
void Box12Press();
void Pen1Press();
void Pen2Press();
void Pen3Press();
void Pen4Press();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawImage(TImage *Aimage);
void DrawBox(TBox *Abox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
